/*
 * PopAdapter.java
 * classes : cn.com.bril.meeting.adapter.PopAdapter
 * @author 李小娇
 * V 1.0.0
 * Create at 2016-10-9 下午2:19:58
 */
package cn.bsl.bxbg.zhiban.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.TextView;

import java.util.List;

import cn.bsl.bxbg.zhiban.R;


/**
 * @title: PopAdapter.java
 * @package：cn.com.bril.meeting.adapter.PopAdapter
 * @description: TODO
 * @author 李小娇
 * @time：create at 2016-10-9 下午2:19:58
 */
public class PopAdapter extends BaseAdapter {
	private static final String TAG = "PopAdapter";
	private Context context;
	private List<String> list;


	public PopAdapter(Context context, List<String> list) {
		this.context = context;
		this.list = list;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.Adapter#getCount()
	 */
	@Override
	public int getCount() {
		return list.size();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.Adapter#getItem(int)
	 */
	@Override
	public Object getItem(int position) {
		return position;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.Adapter#getItemId(int)
	 */
	@Override
	public long getItemId(int position) {
		return position;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.Adapter#getView(int, android.view.View,
	 * android.view.ViewGroup)
	 */
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder = null;
		if (convertView == null) {
			holder = new ViewHolder();
			convertView = LayoutInflater.from(context).inflate(R.layout.pop_item, null);
			holder.checkBox = (CheckBox) convertView.findViewById(R.id.checkbox);
			holder.tv_name = (TextView) convertView.findViewById(R.id.tv_name);
			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}
		holder.tv_name.setText(list.get(position));
		return convertView;
	}

	class ViewHolder {
		CheckBox checkBox;
		TextView tv_name;
	}
}
