package cn.bsl.bxbg.zhiban.utils;

import android.app.Dialog;
import android.content.Context;
import android.view.Gravity;
import android.view.Window;
import android.view.WindowManager;

import cn.bsl.bxbg.zhiban.R;


public class DialogUtil
{
	private static DialogUtil instance;

	private DialogUtil()
	{
	}

	
	public static DialogUtil getInstance()
	{
		if (instance == null)
		{
			instance = new DialogUtil();
		}
		return instance;
	}

	
	public LoadDialog showLoadDialog(Context context, String text)
	{
		LoadDialog dialog = new LoadDialog(context, R.style.popup_dialog_style);
		Window window = dialog.getWindow();
		window.setGravity(Gravity.TOP);
		
		WindowManager mWindowManager = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
		WindowManager.LayoutParams lp = window.getAttributes();
		lp.y = 60;// 设置y坐标
		window.setAttributes(lp);
		window.setWindowManager(mWindowManager, null, null);
		dialog.setCanceledOnTouchOutside(false);// 设置点击Dialog外部任意区域不可关闭Dialog
		dialog.show();
		if (text != null && !text.equals(""))
		{
			dialog.setLoadText(text);
		}
		return dialog;
	}

	
	public LoadDialog showLoadDialog(Context context)
	{
		LoadDialog dialog = new LoadDialog(context, R.style.popup_dialog_style);
		Window window = dialog.getWindow();
		window.setGravity(Gravity.TOP);
		
		WindowManager mWindowManager = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
		WindowManager.LayoutParams lp = window.getAttributes();
		lp.y = 60;// 设置y坐标
		window.setAttributes(lp);
		window.setWindowManager(mWindowManager, null, null);
		dialog.setCanceledOnTouchOutside(false);// 设置点击Dialog外部任意区域不可关闭Dialog
		dialog.show();
		return dialog;
	}

	
	public void dialogDismiss(Dialog dialog)
	{
		if (dialog != null && dialog.isShowing())
		{
			dialog.dismiss();
		}
	}

}
