package cn.bsl.bxbg.zhiban.view;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.GridView;

import com.bril.baoding.studio.aidl.GetUserid;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.adapter.HomeAdapter;
import cn.bsl.bxbg.zhiban.bean.MenuBean;
import cn.bsl.bxbg.zhiban.bean.TimeBean;
import cn.bsl.bxbg.zhiban.net.client.DutyPlanClient;
import cn.bsl.bxbg.zhiban.utils.Constant;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class MainActivity extends BaseActivity implements AdapterView.OnItemClickListener {

    @BindView(R.id.home_gv)
    GridView homeGv;
    private GetUserid mService;
    private static final String TAG = "MainActivity";
    private DutyPlanClient dutyPlanClient;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        bindService();
        initTab();

    }

    @Override
    protected void onResume() {
        super.onResume();
        initData();
    }

    private void bindService() {

        Intent intent = new Intent();
        intent.setComponent(
                new ComponentName("com.bril.baoding.studio", "com.bril.baoding.studio.service.AIDLService"));
        bindService(intent, mServiceConnection, Context.BIND_AUTO_CREATE);
    }

    private void initTab() {
        homeGv.setAdapter(new HomeAdapter(menuData()));
        homeGv.setOnItemClickListener(this);
    }

    private void initData() {
        dutyPlanClient = new DutyPlanClient();
        dutyPlanClient.timeBean().enqueue(new Callback<TimeBean>() {
            @Override
            public void onResponse(Call<TimeBean> call, Response<TimeBean> response) {
                Constant.systemDate = response.body().getSystemDate();
                Constant.systemTime = response.body().getSystemTime();
            }

            @Override
            public void onFailure(Call<TimeBean> call, Throwable t) {
                t.printStackTrace();
            }
        });
    }

    private List<MenuBean> menuData() {
        List<MenuBean> menuList = new ArrayList<>();
        MenuBean fbjl = new MenuBean(R.drawable.zb_info, "值班信息");
        MenuBean fbj2 = new MenuBean(R.drawable.zb_table, "值班表");
        MenuBean fbj3 = new MenuBean(R.drawable.tb_record, "调班记录");
        MenuBean fbj4 = new MenuBean(R.drawable.waitme, "待办事项");
        MenuBean fbj5 = new MenuBean(R.drawable.jiaoban_record,"交接班记录");
        menuList.add(fbjl);
        menuList.add(fbj2);
        menuList.add(fbj3);
        menuList.add(fbj4);
        menuList.add(fbj5);
        return menuList;
    }

    private ServiceConnection mServiceConnection = new ServiceConnection() {

        @Override
        public void onServiceDisconnected(ComponentName arg0) {
            mService = null;
        }

        @Override
        public void onServiceConnected(ComponentName arg0, IBinder arg1) {
            mService = GetUserid.Stub.asInterface(arg1);
            try {
                Constant.USER_ID = mService.getUserid();
                Constant.USER_NAME = mService.getUsername();
            } catch (RemoteException e) {
                e.printStackTrace();
            }

            Log.d(TAG, "onServiceConnected: " + Constant.USER_NAME);
        }
    };

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Intent intent = new Intent();
        switch (position) {
            case 0:
                intent.setClass(MainActivity.this, ZhibanInfoActivity.class);
                break;
            case 1:
                intent.setClass(MainActivity.this, ZhibanTableActivity.class);
                break;
            case 2:
                intent.setClass(MainActivity.this, TiaobanRecordActivity.class);
                break;
            case 3:
                intent.setClass(MainActivity.this, WaitMeActivity.class);
                break;
            case 4:
                intent.setClass(MainActivity.this, DutyTransferActivity.class);
                break;
        }
        startActivity(intent);
    }
}
