package cn.bsl.bxbg.zhiban.view;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.net.client.DutyPlanClient;
import cn.bsl.bxbg.zhiban.net.response.TiaobanBean;
import cn.bsl.bxbg.zhiban.utils.Constant;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.functions.Consumer;
import io.reactivex.schedulers.Schedulers;
import me.texy.treeview.TreeNode;
import me.texy.treeview.TreeView;

public class TiaoBanPublish extends BaseActivity {

    private TreeNode root;
    private TreeView treeView;
    private static final String TAG = "TiaoBanPublish";
    @BindView(R.id.reason)
    EditText reason;
    @BindView(R.id.button)
    TextView button;
    @BindView(R.id.choose_result)
    TextView chooseResult;
    @BindView(R.id.choose_time_area)
    TextView chooseTimeArea;
    @BindView(R.id.daibanLeader)
    CheckBox daibanLeader;
    @BindView(R.id.choose_time)
    LinearLayout chooseTime;
    private String morning;
    private String noon;
    private String evening;
    private String leaderChange;
    private DutyPlanClient dutyPlanClient = new DutyPlanClient();
    private String id;
    private String dutyTime;
    private boolean isLeader = false;
    private String departMent;
    private int approveID;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tiao_ban_publish);
        ButterKnife.bind(this);
        initData();
        initView();
    }

    private void initData() {
        id = getIntent().getStringExtra("id");
        morning = getIntent().getStringExtra("morning");
        noon = getIntent().getStringExtra("noon");
        evening = getIntent().getStringExtra("evening");
        dutyTime = getIntent().getStringExtra("dutyTime");
        leaderChange = getIntent().getStringExtra("leaderChange");
        departMent = getIntent().getStringExtra("department");
        if (!leaderChange.equals(Constant.USER_NAME)) {
            daibanLeader.setVisibility(View.GONE);
        }
    }

    private void initView() {
        daibanLeader.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    chooseTime.setVisibility(View.GONE);
                    isLeader = true;
                } else {
                    chooseTime.setVisibility(View.VISIBLE);
                    isLeader = false;
                }
            }
        });
    }


    @OnClick({R.id.change_people, R.id.choose_time, R.id.button})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.change_people:
                Intent intent = new Intent(this, AddMeetingPersonActivity2.class);
                startActivityForResult(intent, 0x00);
                break;
            case R.id.choose_time:
                showTimeSelector();
                break;
            case R.id.button:
                submit(isLeader);
                break;
        }
    }

//    private void leaderTiaoban(String choose_leader,)

    private void tiaoBan(String choose_person, String choose_time, String choose_reason) {
        String timeStatus="";
        if (choose_time.equals("08:30 - 12:00")) {
            // morning
            timeStatus = "0";
        } else if (choose_time.equals("12:00 - 18:30")) {
            // noon
            timeStatus = "1";
        } else if (choose_time.equals("18:30 - 08:30")){
            // evening
            timeStatus = "2";
        } else if (choose_time.equals("isLeader")) {
            timeStatus = "3";
        }
        dutyPlanClient.tiaobanBean(approveID+"",choose_person, id, choose_reason, dutyTime, timeStatus,departMent)
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Consumer<TiaobanBean>() {
                    @Override
                    public void accept(TiaobanBean tiaobanBean) throws Exception {
                        Toast.makeText(TiaoBanPublish.this, "发起调班成功，请等待对方确认", Toast.LENGTH_SHORT).show();
                        finish();
                    }
                }, Throwable::printStackTrace);
    }

    private void submit(boolean leaderStatus) {

        if (leaderStatus) {
            String choose_person = chooseResult.getText().toString();
            String choose_reason = reason.getText().toString();
            if (TextUtils.isEmpty(choose_reason)) {
                Toast.makeText(this, "请输入调班原因", Toast.LENGTH_SHORT).show();
                return;
            }
            if (choose_person.equals("请选择变更人")) {
                Toast.makeText(this, "请选择变更人", Toast.LENGTH_SHORT).show();
                return;
            }
            tiaoBan(choose_person, "isLeader", choose_reason);
        } else {
            String choose_person = chooseResult.getText().toString();
            String choose_time = chooseTimeArea.getText().toString();
            String choose_reason = reason.getText().toString();
            if (TextUtils.isEmpty(choose_reason)) {
                Toast.makeText(this, "请输入调班原因", Toast.LENGTH_SHORT).show();
                return;
            }
            if (choose_time.equals("选择您要调整的时间段")) {
                Toast.makeText(this, "请选择时间", Toast.LENGTH_SHORT).show();
                return;
            }
            if (choose_person.equals("请选择变更人")) {
                Toast.makeText(this, "请选择变更人", Toast.LENGTH_SHORT).show();
                return;
            }

            tiaoBan(choose_person, choose_time, choose_reason);
        }



    }

    private void showTimeSelector() {
        List<String> times = new ArrayList<>(3);
        if (morning.contains(Constant.USER_NAME)) {
            times.add("08:30 - 12:00");
        }
        if (noon.contains(Constant.USER_NAME)) {
            times.add("12:00 - 18:30");
        }

        if (evening.contains(Constant.USER_NAME)) {
            times.add("18:30 - 08:30");
        }

        String[] strings = times.toArray(new String[0]);
        final AlertDialog publish_sign_type = new AlertDialog
                .Builder(this)
                .setTitle("请选择时间段")
                .setItems(strings, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        chooseTimeArea.setText(strings[which]);
                    }
                })
                .create();

        publish_sign_type.show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 0x00 && data != null) {
            Bundle bundles = data.getExtras();
            TreeNode singleTreeNode = (TreeNode) bundles.getSerializable("result");

            approveID = Integer.parseInt(singleTreeNode.getUserId());
            String approveName = (String) singleTreeNode.getValue();
            chooseResult.setText(approveName);
        }
    }

}
