package cn.bsl.bxbg.zhiban.view;

import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.ViewPager;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.fragment.TiaoBanFinishFragment;
import cn.bsl.bxbg.zhiban.fragment.TiaoBanNotFinishFragment;

public class TiaobanRecordActivity extends BaseActivity {

    private ArrayList<Fragment> waitMeFinishFragments = new ArrayList<>();
    private ViewPagerAdapter viewPagerAdapter;
    @BindView(R.id.tb_layout)
    TabLayout tbLayout;
    @BindView(R.id.tb_viewpager)
    ViewPager tbViewpager;

    private String[] mTitles = new String[]{"已完成", "未完成"};
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tiaoban_record);
        ButterKnife.bind(this);
        initView();
    }

    private void initView() {
        viewPagerAdapter = new ViewPagerAdapter(getSupportFragmentManager());
        waitMeFinishFragments.add(new TiaoBanFinishFragment());
        waitMeFinishFragments.add(new TiaoBanNotFinishFragment());
        tbViewpager.setAdapter(viewPagerAdapter);
        tbLayout.setupWithViewPager(tbViewpager);
    }




    public class ViewPagerAdapter extends FragmentStatePagerAdapter {

        public ViewPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            return waitMeFinishFragments.get(position);
        }

        @Override
        public int getCount() {
            return waitMeFinishFragments.size();
        }

        @Override
        public CharSequence getPageTitle(int position) {
            return mTitles[position];
        }
    }
}
